Index: /trunk/doc/CHANGES.OS2
===================================================================
--- /trunk/doc/CHANGES.OS2	(revision 398)
+++ /trunk/doc/CHANGES.OS2	(revision 399)
@@ -4,4 +4,31 @@
 
 CHANGES
+
+1.6.0 Build 25 GA3 (2012-07-21)
+
+  - Updated OpenJDK sources to b25 (release May, 07, 2012). The main changes in
+    b25 are the latest round of security updates (in jdk and corba repositories)
+    and a number of other fixes. The full list of changes is located here:
+
+    https://blogs.oracle.com/openjdk6releases/entry/openjdk_6_b25_available
+
+  - Fix a hang in the TCP/IP Configuration application when saving the changes.
+
+  - Fix warnings about stack guard pages that could eventually lead crash the
+    Java application.
+
+  - Add related changes to make the IcedTea-Web (Java) browser plugin work.
+
+  - Fix a possible secondary crash when generating the Java crash report.
+
+  - Change the version numbering scheme to 1.6.0_BB-bNN-name where BB is the
+    upstream Build number, NN is the OS/2 sequential build number and name is
+    a symbolic name of the release. This release's version is 1.6.0_25-b01-GA3.
+
+  - Make sure the BEGINLIBPATH setting is not necessary for JAVA.EXE and
+    JAVAW.EXE binaries (and for creating a JVM by loading JVM.DLL directly).
+    It is only necessary for JAVAC.EXE and other SDK tools.
+
+
 
 1.6.0 Build 24 GA2 (2012-03-19)
Index: /trunk/doc/README.OS2
===================================================================
--- /trunk/doc/README.OS2	(revision 398)
+++ /trunk/doc/README.OS2	(revision 399)
@@ -1,7 +1,7 @@
 OpenJDK 6 for OS/2 and eCS
 
-Version 1.6.0 Build 24 GA2 (2012-03-19)
-
-This is an official release of Build 22 intended for general use.
+Version 1.6.0 Build 25 GA3 (2012-07-21)
+
+This is an official release of Build 25 intended for general use.
 
 
@@ -28,7 +28,7 @@
   - A OS/2 Warp 4 Fixpack 16+, OS/2 Warp 4.5 or eComStation operating system.
 
-  - LIBC runtime version 0.6.4 (you probably have it already installed):
-
-    ftp://ftp.netlabs.org/pub/libc/libc-0_6_4-csd4.wpi
+  - LIBC runtime version 0.6.5 (you probably have it already installed):
+
+    ftp://ftp.netlabs.org/pub/libc/libc-0_6_5-csd5.wpi
 
   - GCC 4 runtime libraries:
@@ -36,7 +36,7 @@
     ftp://ftp.netlabs.org/pub/gcc/gcc4core-1_2_1.wpi
 
-  - Odin runtime version 0.8.4 or above:
-
-    ftp://ftp.netlabs.org/pub/odin/0.8.4/odin-0.8.4.zip
+  - Odin runtime version 0.8.5 or above:
+
+    ftp://ftp.netlabs.org/pub/odin/0.8.5/odin-0.8.5.zip
 
   - Extended system tray widget for XCenter version 0.1.1 or above (optional,
@@ -45,4 +45,9 @@
     ftp://ftp.netlabs.org/pub/qt4/xsystray/xsystray-0_1_1.wpi
 
+If you use the YUM/RPM package manager, you may install all the requirements
+with a single command from the command line (except the system tray widget):
+
+    yum install libc libgcc446 libodin
+
 
 
@@ -50,22 +55,27 @@
 
   The OpenJDK product is distributed in two packages: the JRE and the SDK
-  (which includes a copy of JRE). Simply take a necessary package and unzip it
-  to a directory of your choice. You will need to add the \bin subdirectory
-  inside this directory to PATH and BEGINLIBPATH to allow for starting Java
-  executables from an arbitrary location:
+  (which includes a copy of JRE). Simply take the necessary package and unzip it
+  to a directory of your choice. You will need to add the "bin" subdirectory
+  inside this directory to the PATH environment variable to allow for starting
+  Java programs from an arbitrary location (using JAVA.EXE and JAVAW.EXE):
 
     set PATH=<directory>\bin;%PATH%
+
+  Note that if you use the SDK package, you will also need to add this "bin"
+  subdirectory to the BEGINLIBPATH environment variable (in order to run
+  JAVAC.EXE, JAR.EXE and other development tools):
+
     set BEGINLIBPATH=<directory>\bin;%BEGINLIBPATH%
 
   Also make sure there are no traces of other Java installations in the
-  environment because this is known to make problems (in particular, this means
-  that the CLASSPATH/JAVA_HOME/SWING_HOME environment variables should not be
-  set).
-
-  Alternatively, you may add this subdirectory to PATH and LIBPATH statements
-  of your CONFIG.SYS (and reboot) to make the given Java installation the
-  default one.
-
-  Please read the further sections (especially the "CURRENT LIMITATIONS" section
+  environment because this is known to make problems. In particular, you should
+  check that the CLASSPATH/JAVA_HOME/SWING_HOME environment variables are not
+  set.
+
+  Alternatively, you may add the "bin" subdirectory to PATH and LIBPATH
+  statements of your CONFIG.SYS (and reboot) to make the given Java installation
+  the default one.
+
+  Please read further sections (especially the "CURRENT LIMITATIONS" section
   below) to make sure that you are aware of possible problems you may run into
   while running Java applications using this product.
Index: /trunk/tools/CreateImageZIPs.cmd
===================================================================
--- /trunk/tools/CreateImageZIPs.cmd	(revision 398)
+++ /trunk/tools/CreateImageZIPs.cmd	(revision 399)
@@ -1,7 +1,7 @@
 /*REXX*/
 
-ver_id = 'openjdk6_b24'
+ver_id = 'openjdk6_b25'
 
-build_id = 'ga2-20120319'
+build_id = 'ga3-20120721'
 
 src_path = '..'